"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _assign = require("babel-runtime/core-js/object/assign");

var _assign2 = _interopRequireDefault(_assign);

exports.default = dllConfig;

var _path = require("path");

var _webpack = require("webpack");

var _webpack2 = _interopRequireDefault(_webpack);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
* @Author: insane.luojie
* @Date:   2017-09-21 11:34:36
* @Last Modified by:   insane.luojie
* @Last Modified time: 2017-09-28 11:01:14
*/
function dllConfig(base) {
	var name = 'vendor';
	var cacheDir = this.options.cacheDir;

	// todo 合并 vendor
	var nodeModulesDir = (0, _path.join)(__dirname, '..', '..', '..', 'node_modules');

	var conf = (0, _assign2.default)({}, {
		name: name,
		entry: {
			vue: this.vendors()
		},
		output: {
			path: cacheDir,
			filename: 'vendor.[hash:8].js',
			library: 'vendor_[hash]'
		},
		resolve: {
			extensions: ['.js'],
			modules: ["node_modules", nodeModulesDir],
			alias: {
				'vue$': 'vue/dist/vue.esm.js' // 'vue/dist/vue.common.js' for webpack 1,
			}
		},
		plugins: [new _webpack2.default.DllPlugin({
			context: this.options.rootDir,
			// The path to the manifest file which maps between
			// modules included in a bundle and the internal IDs
			// within that bundle
			path: (0, _path.resolve)(cacheDir, 'vendor-manifest.json'),
			name: 'vendor_[hash]'
		})],
		devtool: this.options.dev ? 'cheap-module-source-map' : 'hidden-source-map'
	});

	// 添加 production 插件
	if (!this.options.dev) {
		conf.plugins.push(new _webpack2.default.optimize.UglifyJsPlugin({
			sourceMap: false,
			extractComments: {
				filename: 'LICENSES'
			},
			uglifyOptions: {
				ie8: true,
				ecma: 6
			},
			compress: {
				warnings: false
			}
		}));
	}

	return conf;
}