'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

exports.default = styleLoader;

var _extractTextWebpackPlugin = require('extract-text-webpack-plugin');

var _extractTextWebpackPlugin2 = _interopRequireDefault(_extractTextWebpackPlugin);

var _path = require('path');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function styleLoader(ext) {
  var _this = this;

  var loaders = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var isVueLoader = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

  // Normalize loaders
  loaders = (Array.isArray(loaders) ? loaders : [loaders]).map(function (loader) {
    if (typeof loader === 'string') {
      loader = { loader: loader };
    }
    return (0, _assign2.default)({
      options: {
        sourceMap: _this.options.build.cssSourceMap
      }
    }, loader);
  }).concat({
    loader: "sass-resources-loader",
    options: {
      resources: this.options.resources
    }
  });

  // https://github.com/postcss/postcss-loader
  var postcssLoader = void 0;
  if (!isVueLoader && this.options.build.postcss) {
    postcssLoader = {
      loader: 'postcss-loader',
      options: this.options.build.postcss
    };
    if (postcssLoader.options === true) {
      postcssLoader.options = {
        sourceMap: this.options.build.cssSourceMap
      };
    }
  }

  // https://github.com/webpack-contrib/css-loader
  var cssLoader = {
    loader: 'css-loader',
    options: {
      minimize: true,
      importLoaders: 1,
      sourceMap: this.options.build.cssSourceMap,
      alias: {
        '/static': (0, _path.join)(this.options.srcDir, 'static'),
        '/assets': (0, _path.join)(this.options.srcDir, 'assets')
      }
    }

    // https://github.com/vuejs/vue-style-loader
  };var vueStyleLoader = {
    loader: 'vue-style-loader',
    options: {
      sourceMap: this.options.build.cssSourceMap
    }
  };

  if (this.options.build.extractCSS && !this.options.dev) {
    return _extractTextWebpackPlugin2.default.extract({
      fallback: vueStyleLoader,
      use: [cssLoader, postcssLoader].concat((0, _toConsumableArray3.default)(loaders)).filter(function (l) {
        return l;
      })
    });
  }

  return [vueStyleLoader, cssLoader, postcssLoader].concat((0, _toConsumableArray3.default)(loaders)).filter(function (l) {
    return l;
  });
}