"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _assign = require("babel-runtime/core-js/object/assign");

var _assign2 = _interopRequireDefault(_assign);

exports.default = vueLoader;

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function vueLoader() {
	var _this = this;

	// https://vue-loader.vuejs.org/en
	var config = {
		postcss: this.options.build.postcss,
		extractCSS: this.options.build.extractCSS,
		cssSourceMap: this.options.build.cssSourceMap,
		preserveWhitespace: false,
		loaders: {
			js: {
				loader: "babel-loader",
				exclude: function exclude(str) {
					return (/node_modules/.test(str) && _this.options.build.babelInclude.every(function (item) {
							return !item.test(str);
						})
					);
				},
				options: (0, _assign2.default)({}, this.babelOptions)
			},
			// Note: do not nest the `postcss` option under `loaders`
			css: this.styleLoader("css", [], true),
			less: this.styleLoader("less", "less-loader", true),
			scss: this.styleLoader("scss", "sass-loader", true),
			sass: this.styleLoader("sass", {
				loader: "sass-loader",
				options: {
					indentedSyntax: true
				}
			}, true),
			stylus: this.styleLoader("stylus", "stylus-loader", true),
			styl: this.styleLoader("stylus", "stylus-loader", true)
		},
		template: {
			doctype: "html" // For pug, see https://github.com/vuejs/vue-loader/issues/55
		}
	};

	// Return the config
	return config;
}