"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _promise = require("babel-runtime/core-js/promise");

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

/**
 * 获取 route 文件
 */
var getRoutes = function () {
	var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(opts) {
		var files;
		return _regenerator2.default.wrap(function _callee$(_context) {
			while (1) {
				switch (_context.prev = _context.next) {
					case 0:
						files = _glob2.default.sync("pages/**/*.vue", { cwd: opts.srcDir });

						opts.router.routes = (0, _utils.createRoutes)(files, opts.srcDir);

					case 2:
					case "end":
						return _context.stop();
				}
			}
		}, _callee, this);
	}));

	return function getRoutes(_x) {
		return _ref.apply(this, arguments);
	};
}();

/**
 * 获取module 文件
 */


var getModules = function () {
	var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(opts) {
		var files;
		return _regenerator2.default.wrap(function _callee2$(_context2) {
			while (1) {
				switch (_context2.prev = _context2.next) {
					case 0:
						files = _glob2.default.sync("modules/*/index.vue", { cwd: opts.srcDir });
						//

						opts.runtime.modules = files.map(function (item) {
							/modules\/(.+)\/index/.exec(item);
							var name = RegExp.$1;
							return {
								name: name,
								varName: name.replace(/-/g, "_"),
								path: item
							};
						});

					case 2:
					case "end":
						return _context2.stop();
				}
			}
		}, _callee2, this);
	}));

	return function getModules(_x2) {
		return _ref2.apply(this, arguments);
	};
}();

/**
 * 获取components 文件
 */


var getComponents = function () {
	var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3(opts) {
		var files;
		return _regenerator2.default.wrap(function _callee3$(_context3) {
			while (1) {
				switch (_context3.prev = _context3.next) {
					case 0:
						files = _glob2.default.sync("components/*/index.vue", { cwd: opts.srcDir });

						opts.runtime.components = files.map(function (item) {
							/components\/(.+)\/index/.exec(item);
							var name = RegExp.$1;
							return {
								name: name,
								varName: name.replace(/-/g, "_"),
								path: item
							};
						});

					case 2:
					case "end":
						return _context3.stop();
				}
			}
		}, _callee3, this);
	}));

	return function getComponents(_x3) {
		return _ref3.apply(this, arguments);
	};
}();

var _lodash = require("lodash");

var _lodash2 = _interopRequireDefault(_lodash);

var _fsExtra = require("fs-extra");

var _path = require("path");

var _utils = require("./utils");

var _glob = require("glob");

var _glob2 = _interopRequireDefault(_glob);

var _hashSum = require("hash-sum");

var _hashSum2 = _interopRequireDefault(_hashSum);

var _debug = require("debug");

var _debug2 = _interopRequireDefault(_debug);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var files = ["assets/reset.less", "api.js", "app.js", "router.js", "components.js", "plugins.js", "store.js", "views/app.html", "layouts/app.vue", "layouts/404.vue"]; /* eslint-disable */

/*
 * @Author: insane.luojie
 * @Date:   2017-09-20 15:05:33
 * @Last Modified by: insane.luojie
 * @Last Modified time: 2017-11-26 22:39:51
 */

exports.default = {
	generate: function () {
		var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(opts) {
			var _this = this;

			var context, relativeToBuild, sources;
			return _regenerator2.default.wrap(function _callee5$(_context5) {
				while (1) {
					switch (_context5.prev = _context5.next) {
						case 0:
							relativeToBuild = function relativeToBuild(path) {
								return (0, _utils.relativeTo)(opts.buildDir, path);
							};

							(0, _debug2.default)("> 生成路由...");
							getRoutes(opts);

							getModules(opts);
							getComponents(opts);

							context = {
								opts: opts,
								dev: opts.dev,
								router: opts.router,
								debug: opts.debug || false,
								uniqBy: _lodash2.default.uniqBy
							};
							sources = files.map(function (file) {
								return {
									name: file,
									src: (0, _path.resolve)(opts.bladeDir, file),
									dest: file
								};
							});
							_context5.next = 9;
							return _promise2.default.all(sources.map(function () {
								var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(_ref5) {
									var name = _ref5.name,
									    src = _ref5.src,
									    dest = _ref5.dest;
									var fileContent, content, templateOption, template, path, dateFS;
									return _regenerator2.default.wrap(function _callee4$(_context4) {
										while (1) {
											switch (_context4.prev = _context4.next) {
												case 0:
													_context4.next = 2;
													return (0, _fsExtra.readFile)(src, "utf-8");

												case 2:
													fileContent = _context4.sent;
													content = "";

													if (/\.html$/.test(src)) {
														content = fileContent;
													} else {
														templateOption = {
															imports: {
																relativeToBuild: relativeToBuild,
																hash: _hashSum2.default,
																r: _utils.r,
																plugins: opts.plugins,
																components: opts.runtime.components,
																modules: opts.runtime.modules,
																opts: opts,
																wp: _utils.wp,
																wChunk: _utils.wChunk
															}
														};
														template = _lodash2.default.template(fileContent, templateOption);

														content = template(context);
													}

													path = (0, _path.resolve)(opts.buildDir, dest);
													_context4.next = 8;
													return (0, _fsExtra.mkdirp)((0, _path.dirname)(path));

												case 8:
													_context4.next = 10;
													return (0, _fsExtra.writeFile)(path, content, "utf-8");

												case 10:
													dateFS = Date.now() / 1000 - 1000;
													return _context4.abrupt("return", (0, _fsExtra.utimes)(path, dateFS, dateFS));

												case 12:
												case "end":
													return _context4.stop();
											}
										}
									}, _callee4, _this);
								}));

								return function (_x5) {
									return _ref6.apply(this, arguments);
								};
							}()));

						case 9:
							return _context5.abrupt("return", _context5.sent);

						case 10:
						case "end":
							return _context5.stop();
					}
				}
			}, _callee5, this);
		}));

		function generate(_x4) {
			return _ref4.apply(this, arguments);
		}

		return generate;
	}()
};