"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _promise = require("babel-runtime/core-js/promise");

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _union = require("lodash/union");

var _union2 = _interopRequireDefault(_union);

var _chokidar = require("chokidar");

var _chokidar2 = _interopRequireDefault(_chokidar);

var _webpack = require("webpack");

var _webpack2 = _interopRequireDefault(_webpack);

var _debug = require("debug");

var _debug2 = _interopRequireDefault(_debug);

var _fsExtra = require("fs-extra");

var _watcher = require("./watcher");

var _watcher2 = _interopRequireDefault(_watcher);

var _webpackDevServer = require("webpack-dev-server");

var _webpackDevServer2 = _interopRequireDefault(_webpackDevServer);

var _options = require("./options");

var _options2 = _interopRequireDefault(_options);

var _utils = require("./utils");

var _base = require("./config/base");

var _base2 = _interopRequireDefault(_base);

var _dll = require("./config/dll");

var _dll2 = _interopRequireDefault(_dll);

var _vueLoader = require("./config/vue-loader.config");

var _vueLoader2 = _interopRequireDefault(_vueLoader);

var _styleLoader = require("./config/style-loader");

var _styleLoader2 = _interopRequireDefault(_styleLoader);

var _generator = require("./generator");

var _generator2 = _interopRequireDefault(_generator);

var _path = require("path");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var opn = require("opn"); /*
                           * @Author: insane.luojie
                           * @Date:   2017-09-28 10:49:32
                           * @Last Modified by: insane.luojie
                           * @Last Modified time: 2017-12-04 11:43:21
                           */


var miniStats = {
	modules: false,
	colors: true,
	depth: false
};

var Render = function () {
	function Render(_opts) {
		(0, _classCallCheck3.default)(this, Render);

		this._opts = _opts;
		this.options = _options2.default.create(this._opts);
		// Fields that set on build
		this.compiler = null;
		this.compilers = {};
		this.webpackDevMiddleware = null;
		this.webpackHotMiddleware = null;

		this._env = process.env.NODE_ENV;

		// Bind styleLoader and vueLoader
		this.babelOptions = this.options.babelOptions;

		this.styleLoader = _styleLoader2.default.bind(this);
		this.vueLoader = _vueLoader2.default.bind(this);
	}

	/**
  * 获取第三方vendor
  * @return {array}
  */


	(0, _createClass3.default)(Render, [{
		key: "vendors",
		value: function vendors() {
			return (0, _union2.default)(["vue", "vue-router", "vuex", "axios"], this.options.vendors);
		}

		/**
   * 创建路由，插件，组件文件
   * @return {[type]} [description]
   */

	}, {
		key: "collectFiles",
		value: function () {
			var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee() {
				return _regenerator2.default.wrap(function _callee$(_context) {
					while (1) {
						switch (_context.prev = _context.next) {
							case 0:
								_context.next = 2;
								return (0, _fsExtra.remove)((0, _utils.r)(this.options.buildDir));

							case 2:
								_context.next = 4;
								return this.generateRoutesAndFiles();

							case 4:
							case "end":
								return _context.stop();
						}
					}
				}, _callee, this);
			}));

			function collectFiles() {
				return _ref.apply(this, arguments);
			}

			return collectFiles;
		}()
	}, {
		key: "generateRoutesAndFiles",
		value: function () {
			var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2() {
				return _regenerator2.default.wrap(function _callee2$(_context2) {
					while (1) {
						switch (_context2.prev = _context2.next) {
							case 0:
								_context2.next = 2;
								return _generator2.default.generate(this.options);

							case 2:

								// 配置proxy
								console.log("> 动态文件已更新");
								console.log(" ");

							case 4:
							case "end":
								return _context2.stop();
						}
					}
				}, _callee2, this);
			}));

			function generateRoutesAndFiles() {
				return _ref2.apply(this, arguments);
			}

			return generateRoutesAndFiles;
		}()
	}, {
		key: "makeConfig",
		value: function makeConfig(build) {
			var _this = this;

			// 初始化 app compiler
			var configs = [];
			[_base2.default].forEach(function (item) {
				var config = item.call(_this);
				configs[config.name] = config;
			});
			this.configs = configs;

			if (build) {
				return new _promise2.default(function (resolve, reject) {
					(0, _webpack2.default)((0, _keys2.default)(_this.configs).map(function (item) {
						return _this.configs[item];
					}), function (err, stats) {
						if (err) throw err;
						process.stdout.write(stats.toString(miniStats) + "\n\n");
						resolve({
							dir: _this.options.buildDir,
							data: stats.toJson({
								assets: true,
								hash: true
							})
						});
					});
				});
			}
		}
	}, {
		key: "makeDll",
		value: function () {
			var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
				var _this2 = this;

				return _regenerator2.default.wrap(function _callee3$(_context3) {
					while (1) {
						switch (_context3.prev = _context3.next) {
							case 0:
								if (this.options.build.dll) {
									_context3.next = 2;
									break;
								}

								return _context3.abrupt("return", _promise2.default.resolve());

							case 2:
								return _context3.abrupt("return", new _promise2.default(function (resolve, reject) {
									console.log("> [dll] compiling" + "\n");
									(0, _webpack2.default)(_dll2.default.call(_this2), function (err, stats) {
										process.stdout.write(stats.toString({
											modules: false,
											colors: true,
											depth: false
										}) + "\n\n");
										resolve();
									});
								}));

							case 3:
							case "end":
								return _context3.stop();
						}
					}
				}, _callee3, this);
			}));

			function makeDll() {
				return _ref3.apply(this, arguments);
			}

			return makeDll;
		}()

		/**
   * 初始化服务器
   * @return {[type]} [description]
   */

	}, {
		key: "makeServer",
		value: function () {
			var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4(restart) {
				var publicPath, options;
				return _regenerator2.default.wrap(function _callee4$(_context4) {
					while (1) {
						switch (_context4.prev = _context4.next) {
							case 0:
								_context4.next = 2;
								return this.makeDll();

							case 2:

								this.makeConfig();
								publicPath = this.configs.base.output.publicPath;
								options = {
									proxy: this.options.proxy || {},
									hot: true,
									port: this.options.port,
									host: this.options.host,
									open: true,
									stats: "errors-only",
									historyApiFallback: publicPath == "/" ? true : {
										index: publicPath
									},
									publicPath: publicPath
								};


								_webpackDevServer2.default.addDevServerEntrypoints(this.configs.base, options);

								this.configs.base.entry.vendor = this.vendors();

								this.compiler = (0, _webpack2.default)(this.configs.base);
								this.server = new _webpackDevServer2.default(this.compiler, options);

							case 9:
							case "end":
								return _context4.stop();
						}
					}
				}, _callee4, this);
			}));

			function makeServer(_x) {
				return _ref4.apply(this, arguments);
			}

			return makeServer;
		}()

		// 监控文件变化

	}, {
		key: "watch",
		value: function watch() {
			_watcher2.default.call(this);
		}

		/**
   * 构建 production 文件
   * @return {[type]} [description]
   */

	}, {
		key: "build",
		value: function () {
			var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5() {
				return _regenerator2.default.wrap(function _callee5$(_context5) {
					while (1) {
						switch (_context5.prev = _context5.next) {
							case 0:
								_context5.next = 2;
								return this.collectFiles();

							case 2:
								_context5.next = 4;
								return this.makeDll(true);

							case 4:
								return _context5.abrupt("return", this.makeConfig(true));

							case 5:
							case "end":
								return _context5.stop();
						}
					}
				}, _callee5, this);
			}));

			function build() {
				return _ref5.apply(this, arguments);
			}

			return build;
		}()
	}, {
		key: "restart",
		value: function restart() {
			var _this3 = this;

			this.options = _options2.default.create(this._opts);
			console.log("> 重启...");
			console.log(" ");
			// 停止compiler
			this.server.close(function () {
				_this3.start(true);
			});
		}

		/**
   * 开启开发服务
   * @param  {boolean} restart 是否重启
   * @return {[type]}         [description]
   */

	}, {
		key: "start",
		value: function () {
			var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6(restart) {
				return _regenerator2.default.wrap(function _callee6$(_context6) {
					while (1) {
						switch (_context6.prev = _context6.next) {
							case 0:
								_context6.next = 2;
								return this.collectFiles();

							case 2:
								_context6.next = 4;
								return this.makeServer();

							case 4:
								this.server.listen(this.options.port);
								if (!restart) {
									this.watch();
								}

							case 6:
							case "end":
								return _context6.stop();
						}
					}
				}, _callee6, this);
			}));

			function start(_x2) {
				return _ref6.apply(this, arguments);
			}

			return start;
		}()
	}]);
	return Render;
}();

exports.default = Render;