"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _assign = require("babel-runtime/core-js/object/assign");

var _assign2 = _interopRequireDefault(_assign);

var _chokidar = require("chokidar");

var _chokidar2 = _interopRequireDefault(_chokidar);

var _lodash = require("lodash");

var _lodash2 = _interopRequireDefault(_lodash);

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * 监控文件目录
 * pages web.config.js
 * @return {} 
 */
function startWatcher() {
	var _this = this;

	var patterns = [(0, _utils.r)(this.options.srcDir, "store/index.js"), (0, _utils.r)(this.options.srcDir, "modules/**/index.vue"), (0, _utils.r)(this.options.srcDir, "components/**/index.vue"), (0, _utils.r)(this.options.srcDir, "pages/**/*.vue")];

	var options = (0, _assign2.default)({}, this.options.watchers.chokidar, {
		ignoreInitial: true
	});

	var refreshFiles = _lodash2.default.debounce(function () {
		return _this.generateRoutesAndFiles();
	}, 500);
	var restart = _lodash2.default.debounce(function () {
		return _this.restart();
	}, 500);

	// 重新生成代码
	var filesWatcher = _chokidar2.default.watch(patterns, options).on("add", refreshFiles).on("unlink", refreshFiles);

	_chokidar2.default.watch([(0, _utils.r)(this.options.srcDir, "web.config.js")]).on("change", function () {
		restart();
	});
}

exports.default = startWatcher;