"use strict";

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _fsExtra = require("fs-extra");

var _path = require("path");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * @Author: insane.luojie
 * @Date:   2017-09-02 00:46:41
 * @Last Modified by: insane.luojie
 * @Last Modified time: 2017-11-27 20:45:01
 */
var Server = require("../server");
var args = require("minimist")(process.argv.slice(2));
// 解析 -env 参数
// npm run build -- --env=qa
var env = args.env || "production";


process.env.NODE_ENV = env || "production";
process.env.BABEL_ENV = process.env.NODE_ENV;
console.log("> env: ", env, "\n");

var server = Server({ dev: false }).then(function (_ref) {
	var dir = _ref.dir,
	    data = _ref.data;

	var _data$children = (0, _slicedToArray3.default)(data.children, 1),
	    compilation = _data$children[0];

	var assets = compilation.assets.filter(function (item) {
		return !item.name.match(/(map|html)$/);
	}).map(function (item) {
		return item.name;
	});

	var content = {
		hash: data.hash,
		base: compilation.publicPath,
		assets: assets
	};

	(0, _fsExtra.writeJson)((0, _path.join)(dir, "dist", "manifest.json"), content, function (err) {
		if (err) return console.error(err);
		console.log("> manifest generated");
	});
});