"use strict";

var _promise = require("babel-runtime/core-js/promise");

var _promise2 = _interopRequireDefault(_promise);

var _regenerator = require("babel-runtime/regenerator");

var _regenerator2 = _interopRequireDefault(_regenerator);

var _asyncToGenerator2 = require("babel-runtime/helpers/asyncToGenerator");

var _asyncToGenerator3 = _interopRequireDefault(_asyncToGenerator2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/*
 * @Author: insane.luojie 
 * @Date: 2017-11-01 21:02:47 
 * @Last Modified by: insane.luojie
 * @Last Modified time: 2017-11-01 21:06:41
 */
var Server = require("../server");
var args = require("minimist")(process.argv.slice(0));
var axios = require("axios");
var request = require('request-promise');
var fs = require("fs");

var _require = require("path"),
    resolve = _require.resolve,
    join = _require.join;

var dir = resolve(".blade/dist");
var glob = require('glob');
var pkg = require(resolve('package.json'));

var _require2 = require(resolve('.', 'web.config.js')),
    addons = _require2.addons,
    env = _require2.env;

var version = args.version || pkg.version;
var action = args.action;
var needOptions = ["host", "project", "token", "dns", "SENTRY_PROJECT_BASE"];
var README = "可查看文档：https://github.com/doctorwork/blade-scripts/blob/develop/docs/monitor.md";
var sentry = addons && addons.sentry || {};
sentry.SENTRY_PROJECT_BASE = env.SENTRY_PROJECT_BASE;

// 指令参数优先
needOptions.map(function (item) {
    if (args[item]) sentry[item] = args[item];
});

var getFile = function () {
    var _ref = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee(file) {
        var _filePath;

        return _regenerator2.default.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        _filePath = resolve(".blade/dist", file);

                        console.log(_filePath);
                        _context.next = 4;
                        return fs.createReadStream(_filePath);

                    case 4:
                        return _context.abrupt("return", _context.sent);

                    case 5:
                    case "end":
                        return _context.stop();
                }
            }
        }, _callee, undefined);
    }));

    return function getFile(_x) {
        return _ref.apply(this, arguments);
    };
}();

var uploadFile = function () {
    var _ref2 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee2(file) {
        var fileStream;
        return _regenerator2.default.wrap(function _callee2$(_context2) {
            while (1) {
                switch (_context2.prev = _context2.next) {
                    case 0:
                        _context2.next = 2;
                        return getFile(file);

                    case 2:
                        fileStream = _context2.sent;

                        request({
                            method: 'POST',
                            uri: sentry.host + "/api/0/projects/" + sentry.project + "/releases/" + version + "/files/",
                            headers: {
                                Authorization: "Bearer " + sentry.token,
                                'Content-Type': 'multipart/form-data;'
                            },
                            formData: {
                                name: sentry.SENTRY_PROJECT_BASE + "/" + file,
                                file: fileStream
                            }
                        });

                    case 4:
                    case "end":
                        return _context2.stop();
                }
            }
        }, _callee2, undefined);
    }));

    return function uploadFile(_x2) {
        return _ref2.apply(this, arguments);
    };
}();

//检查发布版本是否存在
var checkVersion = function checkVersion() {
    return new _promise2.default(function (resolve, reject) {
        return axios.get(sentry.host + "/api/0/projects/" + sentry.project + "/releases/" + version + "/", {
            headers: { Authorization: "Bearer " + sentry.token }
        }).then(function (result) {
            console.log(">\u5DF2\u5B58\u5728 " + sentry.project + "/release/" + version);
            resolve(true);
        }).catch(function (err) {
            console.log(">\u4E0D\u5B58\u5728 " + sentry.project + "/release/" + version);
            resolve(false);
        });
    });
};
// 创建release
var createRelease = function () {
    var _ref3 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee3() {
        var isExist;
        return _regenerator2.default.wrap(function _callee3$(_context3) {
            while (1) {
                switch (_context3.prev = _context3.next) {
                    case 0:
                        _context3.next = 2;
                        return checkVersion();

                    case 2:
                        isExist = _context3.sent;

                        if (!isExist) {
                            _context3.next = 5;
                            break;
                        }

                        return _context3.abrupt("return", false);

                    case 5:
                        console.log("> \u521B\u5EFA\u4E2D " + sentry.project + "/release/" + version);
                        return _context3.abrupt("return", new _promise2.default(function (resolve, reject) {
                            axios.post(sentry.host + "/api/0/projects/" + sentry.project + "/releases/", {
                                version: version
                            }, {
                                headers: {
                                    'Content-Type': 'application/json',
                                    Authorization: "Bearer " + sentry.token
                                }
                            }).then(function (res) {
                                console.log("> \u521B\u5EFA\u5B8C\u6210 " + sentry.project + "/release/" + version);
                                resolve(true);
                            }).catch(function (err) {
                                console.log("> \u521B\u5EFA\u51FA\u9519 " + sentry.project + "/release/" + version);
                                resolve(false);
                            });
                        }));

                    case 7:
                    case "end":
                        return _context3.stop();
                }
            }
        }, _callee3, undefined);
    }));

    return function createRelease() {
        return _ref3.apply(this, arguments);
    };
}();

// 删除release
var deletRelease = function () {
    var _ref4 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee4() {
        var isExist;
        return _regenerator2.default.wrap(function _callee4$(_context4) {
            while (1) {
                switch (_context4.prev = _context4.next) {
                    case 0:
                        _context4.next = 2;
                        return checkVersion();

                    case 2:
                        isExist = _context4.sent;

                        if (isExist) {
                            _context4.next = 5;
                            break;
                        }

                        return _context4.abrupt("return", false);

                    case 5:
                        console.log("> \u5220\u9664\u4E2D " + sentry.project + "/release/" + version);
                        return _context4.abrupt("return", new _promise2.default(function (resolve, reject) {
                            return axios.delete(sentry.host + "/api/0/projects/" + sentry.project + "/releases/" + version + "/", {
                                headers: { Authorization: "Bearer " + sentry.token }
                            }).then(function (res) {
                                console.log("> \u5220\u9664\u5B8C\u6210 " + sentry.project + "/release/" + version);
                                resolve(true);
                            }).catch(function (err) {
                                console.log("> \u5220\u9664\u51FA\u9519 " + sentry.project + "/release/" + version);
                                resolve(false);
                            });
                        }));

                    case 7:
                    case "end":
                        return _context4.stop();
                }
            }
        }, _callee4, undefined);
    }));

    return function deletRelease() {
        return _ref4.apply(this, arguments);
    };
}();

// 上传文件
var uploadSourceMap = function () {
    var _ref5 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee6() {
        var isExist, fileArray;
        return _regenerator2.default.wrap(function _callee6$(_context6) {
            while (1) {
                switch (_context6.prev = _context6.next) {
                    case 0:
                        _context6.next = 2;
                        return checkVersion();

                    case 2:
                        isExist = _context6.sent;

                        if (!isExist) {
                            _context6.next = 10;
                            break;
                        }

                        _context6.next = 6;
                        return deletRelease();

                    case 6:
                        _context6.next = 8;
                        return createRelease();

                    case 8:
                        _context6.next = 12;
                        break;

                    case 10:
                        _context6.next = 12;
                        return createRelease();

                    case 12:
                        console.log("> \u4E0A\u4F20 " + sentry.project + "/release/" + version + "\n");
                        fileArray = glob.sync('**/*.map', { cwd: dir });

                        fileArray.map(function () {
                            var _ref6 = (0, _asyncToGenerator3.default)( /*#__PURE__*/_regenerator2.default.mark(function _callee5(file) {
                                return _regenerator2.default.wrap(function _callee5$(_context5) {
                                    while (1) {
                                        switch (_context5.prev = _context5.next) {
                                            case 0:
                                                _context5.next = 2;
                                                return uploadFile(file);

                                            case 2:
                                            case "end":
                                                return _context5.stop();
                                        }
                                    }
                                }, _callee5, undefined);
                            }));

                            return function (_x3) {
                                return _ref6.apply(this, arguments);
                            };
                        }());

                    case 15:
                    case "end":
                        return _context6.stop();
                }
            }
        }, _callee6, undefined);
    }));

    return function uploadSourceMap() {
        return _ref5.apply(this, arguments);
    };
}();

// 检查参数是否设置完全
var checkOptions = function checkOptions() {
    var err = [];
    if (!addons || !sentry) {
        console.error(">error\uFF1A\u8BF7\u5728web.config\u4E2D\u914D\u7F6Eaddons\u6269\u5C55\u53C2\u6570\uFF01" + README);
        return false;
    }
    needOptions.map(function (item) {
        if (!sentry[item]) err.push(item);
    });
    if (err.length) {
        console.error(">error\uFF1A" + err.join(",") + " is required\uFF01" + README);
        return false;
    } else return true;
};
if (checkOptions()) {
    switch (action) {
        case 'create':
            createRelease();
            break;
        case 'delete':
            deletRelease();
            break;
        case 'upload':
            uploadSourceMap();
            break;
        case 'check':
            checkVersion();
            break;
        default:
            break;
    }
}